package com.aircraft.modules.system.service;

import com.aircraft.modules.system.domain.EmScenic;
import com.aircraft.utils.PageResult;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author cli
 * @since 2025-07-09
 */
public interface EmScenicService extends IService<EmScenic> {

    /**
     * 条件查询
     * @param example
     * @return
     */
    List<EmScenic> list(EmScenic example);

    /**
     * 分页查询
     * @param example
     * @param page
     * @return
     */
    PageResult<EmScenic> page(EmScenic example, IPage page);

    List<EmScenic> findByAreaId(Long id);

    /**
     * 查询区域下景区名称
     * @param areaId
     * @param name
     * @return
     */
    EmScenic findByAreaIdAndName(Long areaId, String name);

    /**
     * 景区按区域统计数量
     */
    @Transactional
    void countByAreaIdToUpdate();

    /**
     * 根据ID获取对应的景区信息
     *
     * @param id 主键
     * @return {@link EmScenic}
     */
    EmScenic obtainScenicById(Long id);
}
